;
; TRACE  -  FOR USE WITH ASSEMBLE
;
;    20/12/89  AJD
;
;    INPUTS:  filename.DMP
;             filename.COM
;
;    OUTPUT:  TRACE OF EXECUTION THROUGH SOURCE CODE.
;
 JMP %MAIN
;
; DATA AREA
;
HELPMSG ; HELP MESSAGE
   .DB 0D,0A,'The format for this command is:   TRACE pathname',0D,0A
   .DB 0D,0A,'The pathname must not include any suffix (e.g.  .COM).'
   .DB 0D,0A,'Also, the file must have been assembled using the -O option.'
   .DB 0D,0A,'Do not use trace if errors or warnings appeared in the assembly.'
   .DB 0D,0A,'$'
;
IOERR1 .DB 0D,0A,'*** CANNOT ACCESS .DMP FILE ***',0D,0A,'$'
IOERR2 .DB 0D,0A,'*** CANNOT ACCESS .COM FILE ***',0D,0A,'$'
IOERR3 .DB 0D,0A,'*** .DMP FILE IS LONGER THAN 128K ***',0D,0A,'$'
;
TXTCHGAD .DB '-----------------------------------------------------',0D
         .DB '$'
;
TXTIPERR .DB '*** ERROR:  IP VALUE NOT IN SOURCE LISTING ***',0D,0A,'$'
;
TXTREGS ;
 .DB ''
 .DB '' R4E
 .DB ''
 .DB ' AX=      BX=      CX=      DX=      SP=      BP=      SI=    '
 .DB '  DI=           '
 .DB ' DS=      ES=      SS=      CS=      IP=      FLAGS=          '
 .DB '                '
 .DB ''
 .DB '' R4E
 .DB ''
;
TXTBOX ; BOX OUTLINE
 .DB '                                                              '
 .DB '                '
;
TXTLABL  .DB '   FIND LABEL: $'
;
TXTSKIP  .DB '   SKIP TO ADDRESS: '
LASTLABL .DB '    $'
;
TXTNOTF  .DB 'LABEL NOT FOUND.$'
;
TXTWAIT  .DB 'PLEASE WAIT....$'
;
TXTBOT ; BOTTOM LINE OF SCREEN
 .DB 'Esc - quit     F6 - find label     F7 - skip to address     F8 '
 .DB '- switch screen  '
;
TXTQUIT ; QUIT MESSAGE
 .DB '     Press ENTER to quit, or ESC to continue trace.           '
 .DB '                '
;
FLAGTBL  .DB FF,FF,FF,FF,'ODITSZ',FF,'A',FF,'P',FF,'C'
;
SCRNSEG  .DW B000 ; SCREEN SEGMENT (B000 = MDA, B800 = CGA)
;
MXPTHLEN = 0032
PATHNAME .DB 00 R%MXPTHLEN+5
PATHLEN  .DB 00
;
EXTDMP   .DB '.DMP',00 ; EXTENSIONS
EXTCOM   .DB '.COM',00
;
DMPHNDL  .DW 0000 ; HANDLES
COMHNDL  .DW 0000
;
DMPSEG   .DW 0000 ; SEGMENT ADDRESSES
ADRSEG   .DW 0000
COMSEG   .DW 0000
;
ADROFSR  .DW 0000 ; OFFSET OF REFERENCES IN ADRSEG
COMLEN   .DW 0000 ; LENGTH OF COM FILE
;
CHRPTR   .DW 0000 ; CHARACTER POINTER AND SEGMENT ADDRESS
CHRSEG   .DW 0000
;
PBLOCK   .DW 0000,0080,0000,005C,0000,006C,0000
SPSAVE   .DW 0000
SSSAVE   .DW 0000
;
INTSGSAV .DW 0000 ; INT 01 SAVE
INTOFSAV .DW 0000
;
INT3OSAV .DW 0000 ; INT 03 SAVE
INT3SSAV .DW 0000
;
STOREAX  .DW 0000 ; STORES FOR TRACE
STOREIP  .DW 0000
STORECS  .DW 0000
STOREF   .DW 0000
;
STORESP  .DW 0000 ; STORE FOR SP
;
LASTADR  .DW 0000 ; LAST ADDRESS TRACED
;
USERCURS .DW 0000 ; STORED CURSOR POSITIONS
TRACCURS .DW 0000
;
INPUTBLK ; INPUT BLOCK FOR INT 0A
INPUTMAX .DB 00 ; MAXIMUM LENGTH OF INPUT
INPUTACT .DB 00 ; ACTUAL LENGTH
INPUTBUF .DB 00 R32 ; LENGTH = 50
;
SKIPSTOR .DB 00  ; STORES BYTE AT POSITION OF INT 3 TRAP
;
RESTCMDO .DW 0000 ; OFFSET OF REST OF COMMAND LINE
RESTCMDL .DW 0000 ; LENGTH
;
;
; CONVERT ASCII TO HEX NIBBLE
;    INPUT: AL = ASCII VALUE
;   OUTPUT: AL = HEX VALUE
;
CNVNIB   CMP AL,30
         JAE %CNVNIB1
CNVNIB2  MOV AL,00
         RET
CNVNIB1  CMP AL,39
         JA %CNVNIB3
         SUB AL,30
         RET
CNVNIB3  CMP AL,41 ; 'A'
         JB %CNVNIB2
         CMP AL,5A ; 'Z'
         JA %CNVNIB2
         SUB AL,37
         RET
;
; DISPLAY ERROR ANY TERMINATE
;    INPUT:  DX = START OF MESSAGE
;
ERROR    MOV AH,09 ; DISPLAY MESSAGE
         INT 21
         POP AX ; THROW AWAY RETURN ADDRESS
         MOV AX,4C01 ; ERROR
         INT 21 ; TERMINATE
;
; PROCESS COMMAND LINE
;
COMDLINE CMP [0080]B,01
         JA %COMDLIN1
         MOV DX,%HELPMSG
         JMP %ERROR
;
COMDLIN1 MOV CH,00
         MOV CL,[0080]
         DEC CL
         CMP CL,%MXPTHLEN
         JBE %COMDLIN2
         MOV CL,%MXPTHLEN
COMDLIN2 MOV [%PATHLEN],CL
         MOV SI,0082
         MOV DI,%PATHNAME
COMDLIN4 LODSB
         CMP AL,20 ; OTHER PARAMETERS
         JZ %COMDLIN3
         STOSB
         LOOP %COMDLIN4
         MOV AL,2E
         STOSB
         MOV [%RESTCMDL],CX ; ZERO LENGTH
         RET
;
COMDLIN3 MOV AL,[%PATHLEN]
         SUB AL,CL
         MOV [%PATHLEN],AL
         MOV AL,2E ; FINISH OFF PATHNAME
         STOSB
         DEC SI
         MOV [%RESTCMDO],SI ; OFFSET OF REST
         MOV [%RESTCMDL],CX ; LENGTH OF REST
         RET
;
; READ DMP FILE INTO MEMORY
;
READDMP  MOV AH,00 ; SET UP PATH NAME SUFFIX
         MOV AL,[%PATHLEN]
         ADD AX,%PATHNAME
         MOV DI,AX
         MOV SI,%EXTDMP
         MOV CL,05
         MOV CH,00
         REP
         MOVSB
;
         MOV AH,3D ; OPEN FILE
         MOV AL,00 ; ACCESS MODE
         MOV DX,%PATHNAME
         INT 21
         JNC %READDMP1
         MOV DX,%IOERR1
         JMP %ERROR
;
READDMP1 MOV [%DMPHNDL],AX ; SAVE HANDLE
;
         MOV AX,%ENDSPACE
         ADD AX,0010 ; FIND NEXT PARAGRAPH
         MOV CL,04
         SHR AX,CL ; DIVIDE BY 16
         MOV BX,CS
         ADD AX,BX
         MOV [%DMPSEG],AX ; SEGMENT OF LISTING
         MOV [%CHRSEG],AX ; SEGMENT FOR READCHR
         MOV [%CHRPTR]W,0000 ; INTIALISE POINTER
         PUSH DS
         MOV DS,AX
;
         MOV AH,3F
         ES:
         MOV BX,[%DMPHNDL]
         MOV CX,FFFF
         MOV DX,0000
         INT 21 ; READ BLOCK OF FILE
         JNC %READDMP2
READDMP5 MOV DX,%IOERR1
         JMP %ERROR
;
READDMP2 CMP AX,FFFF ; CHECK IF BUFFER FULL
         JNZ %READDMP3
         ES:
         MOV AX,[%DMPSEG]
         ADD AX,1000
         MOV DS,AX
         ES:
         MOV BX,[%DMPHNDL]
         MOV AH,3F
         MOV CX,FFFF
         MOV DX,0000
         INT 21 ; READ SECOND BLOCK OF FILE
         JC %READDMP5
         CMP AX,FFFF
         JNZ %READDMP3
         MOV DX,%IOERR3
         JMP %ERROR
;
READDMP3 MOV BX,DS
         POP DS
         ADD AX,0010
         MOV CL,04
         SHR AX,CL ; DIVIDE BY 16
         ADD AX,BX ; FIND PARAGRAPH OF NEXT SEGMENT
         MOV [%ADRSEG],AX
;
         MOV AH,3E ; CLOSE FILE
         MOV BX,[%DMPHNDL]
         INT 21
         RET
;
; READ CHARACTER FROM DMP FILE IN MEMORY
;    OUTPUT:  AL = CHARACTER
;
READCHR  PUSH BX
         PUSH ES
         MOV AX,[%CHRSEG]
         MOV ES,AX
         MOV BX,[%CHRPTR]
         ES:
         MOV AL,[BX] ; READ CHARACTER
         POP ES
         INC BX
         CMP BX,0000
         JNZ %READCHR1
         ADD [%CHRSEG]W,1000 ; NEXT 64K PAGE
READCHR1 MOV [%CHRPTR],BX ; UPDATE POINTER
         POP BX
         RET
;
; READ UP TO AND INCLUDING NEXT CR/LF
;
READLN   CALL %READCHR
         CMP AL,0D
         JNZ %READLN
         CALL %READCHR ; READ LF
         RET
;
; READ HEX WORD
;    OUTPUT:  AX = VALUE
;             CARRY = SET IF INVALID HEX WORD
;
READWORD PUSH BX
         CALL %READCHR ; 1ST CHAR
         CMP AL,0D ; BLANK LINE
         JNZ %READWRD1
         POP BX
         STC
         RET
READWRD1 CALL %CNVNIB
         MOV CL,04
         SHL AL,CL
         MOV BH,AL
         CALL %READCHR ; 2ND CHAR
         CALL %CNVNIB
         OR BH,AL
         CALL %READCHR ; 3RD CHAR
         CALL %CNVNIB
         MOV CL,04
         SHL AL,CL
         MOV BL,AL
         CALL %READCHR
         CALL %CNVNIB
         OR BL,AL
         MOV AX,BX
         POP BX
         CLC
         RET
;
; MAKE ADDRESS TABLE FROM DMP FILE
;
MAKEADR  CALL %READLN ; THROW AWAY 1ST LINE
         CALL %READLN ; THROW AWAY 2ND LINE
         MOV BX,8000 ; TEMPORARY OFFSET OF REFERENCES
         MOV AX,[%ADRSEG]
         MOV ES,AX
         XOR DI,DI
         XOR DX,DX ; LAST ADDRESS
;
MAKEADR3 MOV CL,00 ; STORE REFERENCE TO DMP FILE
         MOV AX,[%CHRSEG]
         CMP AX,[%DMPSEG]
         JZ %MAKEADR2
         MOV CL,80
MAKEADR2 MOV AX,[%CHRPTR]
         SHR AX,01 ; DIVIDE BY 2
         OR AH,CL  ; ADD SEGMENT BIT
         ES:
         MOV [BX+DI],AX
;
         CALL %READWORD
         JC %MAKEADR1
         CMP AX,DX
         JZ %MAKEADR4 ; ADDRESS UNCHANGED
         STOSW ; STORE IP ADDRESS
         MOV DX,AX
MAKEADR4 CALL %READLN ; THROW AWAY REST OF LINE
         JMP %MAKEADR3
;
MAKEADR1 MOV AX,FFFF ; KEEP ENDING REFERENCE
         STOSW
;
         MOV SI,8000 ; MOVE REFERENCES DOWN TO FREE SOME SPACE
         MOV [%ADROFSR],DI ; OFFSET OF REFERENCES IN ADRSEG
         MOV CX,DI
         SHR CX,1
         PUSH DS
         MOV AX,ES
         MOV DS,AX
         REP
         MOVSW
         POP DS
;
         MOV AX,DI ; SET START OF COMSEG
         ADD AX,0010
         MOV CL,04
         SHR AX,CL
         ADD AX,[%ADRSEG]
         ADD AX,0010 ; ALLOW FOR MEMORY ARENA
         MOV [%COMSEG],AX
;
         MOV AX,DS ; RESTORE ES
         MOV ES,AX
         RET
;
; READ COM FILE INTO MEMORY AND EXECUTE WITH TRACE
;
RUNCOM   MOV AH,00 ; SET UP PATH NAME SUFFIX
         MOV AL,[%PATHLEN]
         ADD AX,%PATHNAME
         MOV DI,AX
         MOV SI,%EXTCOM
         MOV CL,05
         MOV CH,00
         REP
         MOVSB
;
         PUSH ES ; CLEAR TRACE SCREEN
         MOV AX,CS
         MOV ES,AX
         MOV AX,0720
         MOV DI,%TRACSCRN
         MOV CX,07D0
         REP
         STOSW
         MOV [%USERCURS]W,0000 ; SET CURSOR POSITIONS
         MOV [%TRACCURS]W,0500
         POP ES
;
         MOV BX,[%COMSEG] ; SHRINK MEMORY TO SIZE
         SUB BX,0010
         MOV AX,CS
         SUB BX,AX
         MOV ES,AX
         MOV AH,4A
         INT 21
;
         MOV AH,26  ; CREATE NEW PSP
         MOV DX,[%COMSEG]
         INT 21
;
         PUSH ES ; COPY REST OF COMMAND LINE
         MOV ES,[%COMSEG]
         MOV CX,[%RESTCMDL]
         ES:
         MOV [0080],CX
         JCXZ %RUNCOM4
         MOV DI,0081
         MOV SI,[%RESTCMDO]
         REP
         MOVSB
RUNCOM4  POP ES
;
         MOV AX,3D00  ; OPEN COM FILE
         MOV DX,%PATHNAME
         INT 21
         JNC %RUNCOM2
RUNCOM3  MOV DX,%IOERR2
         JMP %ERROR
;
RUNCOM2  MOV [%COMHNDL],AX ; SAVE FILE HANDLE
;
         MOV BX,[%COMHNDL]  ; READ IN COM FILE
         MOV CX,FFFF
         MOV DX,0100 ; OFFSET
         PUSH DS
         MOV AX,[%COMSEG] ; SEGMENT
         MOV DS,AX
         MOV AH,3F
         INT 21
         POP DS
         JC %RUNCOM3
         MOV [%COMLEN],AX ; NUM BYTES READ
         MOV [%LASTADR]W,0000 ; RESET LAST ADDRESS TRACED
;
         MOV AH,3E ; CLOSE FILE
         MOV BX,[%COMHNDL]
         INT 21
         JC %RUNCOM3
;
         PUSH DS ; SET INT 22 FOR TERMINATE
         XOR CX,CX
         MOV DS,CX
         MOV AX,%FINISH
         MOV BX,CS
         CLI
         MOV [0088],AX ; SET INT 22
         MOV [008A],BX
         STI
         PUSH ES
         MOV DX,AX
         CS:
         MOV AX,[%COMSEG]
         MOV ES,AX
         ES:
         MOV [000A],DX ; UPDATE INT 22 SAVE IN PSP
         ES:
         MOV [000C],BX
         POP ES
;
         MOV AX,[000C] ; SET INT 03 FOR TRAP
         CS:
         MOV [%INT3OSAV],AX ; SAVE OLD VALUES
         MOV AX,[000E]
         CS:
         MOV [%INT3SSAV],AX
         MOV AX,CS
         MOV BX,%TRAP
         CLI
         MOV [000C],BX ; SET NEW VECTOR
         MOV [000E],AX
         STI
;
         MOV AX,[0004]  ; SET INT 01 FOR TRACE
         CS:
         MOV [%INTOFSAV],AX ; SAVE OLD VALUES
         MOV AX,[0006]
         CS:
         MOV [%INTSGSAV],AX
         MOV AX,CS
         MOV BX,%TRACE
         CLI
         MOV [0004],BX   ; SET NEW VECTOR
         MOV [0006],AX
         STI
         POP DS
;
         PUSHF  ; TURN SINGLE-STEP MODE ON
         POP AX
         OR AX,0100
         PUSH AX
         POPF
;
         MOV [%SPSAVE],SP
         MOV [%SSSAVE],SS
;
         CLI
         MOV SP,FFFF
         MOV SS,[%COMSEG]
         STI
         XOR AX,AX
         PUSH AX ; PUSH ON ZERO BYTE
         MOV AX,[%COMSEG]
         MOV ES,AX ; SET SEGMENT REGISTERS FOR COM PROGRAM
         MOV DS,AX
;
         PUSHF
         CS:
         MOV AX,[%COMSEG]
         PUSH AX
         MOV AX,0100
         PUSH AX
         XOR AX,AX ; ZERO REGISTERS
         XOR BX,BX
         XOR CX,CX
         XOR DX,DX
         XOR BP,BP
         XOR SI,SI
         XOR DI,DI
         IRET   ; JUMP TO START OF COM PROGRAM
;
;
FINISH   POP AX
         MOV AX,CS ; RESTORE SEGMENT REGISTERS AND STACK
         MOV DS,AX
         MOV ES,AX
         CLI
         MOV SS,[%SSSAVE]
         MOV SP,[%SPSAVE]
         STI
;
         PUSHF  ; TURN SINGLE-STEP MODE OFF
         POP AX
         AND AX,FEFF
         PUSH AX
         POPF
;
         PUSHF   ; RESTORE INT 22 VECTOR
         PUSH DS
         XOR CX,CX
         MOV AX,[000A] ; OLD CONTENTS OF INT 22 VECTOR
         MOV BX,[000C]
         MOV DS,CX
         CLI
         MOV [0088],AX
         MOV [008A],BX
         STI
;
         CS:
         MOV AX,[%INT3OSAV] ; RESTORE INT 03 VECTOR
         CS:
         MOV BX,[%INT3SSAV]
         CLI
         MOV [000C],AX
         MOV [000E],BX
         STI
;
         CS:
         MOV AX,[%INTOFSAV]
         CS:
         MOV BX,[%INTSGSAV]
         CLI
         MOV [0004],AX ; RESTORE INT 01 VECTOR
         MOV [0006],BX
         STI
         POP DS
         POPF
         JNC %RUNCOM1
         MOV DX,%IOERR2
         JMP %ERROR
;
RUNCOM1  RET
;
;
; SAVE SCREEN CONTENTS
;    INPUT:  DI = OFFSET OF SCREEN SAVE AREA
;
SAVESCRN PUSH ES
         PUSH DS
         MOV AX,CS
         MOV ES,AX
         CS:
         MOV AX,[%SCRNSEG]
         MOV DS,AX
         MOV SI,0000
         MOV CX,07D0 ; 2000 WORDS
         REP
         MOVSW
         POP DS
         POP ES
         RET
;
; RESTORE SCREEN CONTENTS
;    INPUT:  SI = OFFSET OF SCREEN SAVE AREA
;
RESTSCRN PUSH ES
         PUSH DS
         MOV AX,CS
         MOV DS,AX
         MOV AX,[%SCRNSEG]
         MOV ES,AX
         MOV DI,0000
         MOV CX,07D0 ; 2000 WORDS
         REP
         MOVSW
         POP DS
         POP ES
         RET
;
; SAVE USER CURSOR POSITION
;
SAVECURS MOV AH,03
         MOV BH,00
         INT 10
         MOV [%USERCURS],DX
         MOV AH,02
         MOV DX,[%TRACCURS] ; SET NEW POSITION
         INT 10
         RET
;
; RESTORE USER CURSOR POSITION
;
RESTCURS MOV AH,03
         MOV BH,00
         INT 10
         MOV [%TRACCURS],DX
         MOV AH,02
         MOV DX,[%USERCURS]
         INT 10
         RET
;
; SHOW NIBBLE ON SCREEN
;    INPUT:  AL = HEX NIBBLE
;            ES:DI = NEXT POSITION ON SCREEN
;
SHOWNIB  CMP AL,0A
         JB %SHOWNIB1
         ADD AL,37
         JMP %SHOWNIB2
SHOWNIB1 ADD AL,30
SHOWNIB2 MOV AH,07 ; DISPLAY ON SCREEN
         STOSW
         RET
;
; SHOW BYTE ON SCREEN
;    INPUT: AL = HEX VALUE
;           ES:DI = NEXT SCREEN POSITION
;
SHOWBYTE PUSH AX
         MOV CL,04
         SHR AL,CL
         CALL %SHOWNIB ; SHOW HIGH
         POP AX
         AND AL,0F
         CALL %SHOWNIB ; SHOW LOW
         RET
;
; SHOW WORD ON SCREEN
;    INPUT:  AX = HEX VALUE
;            ES:DI = NEXT SCREEN POSITION
;
SHOWWORD PUSH AX
         MOV AL,AH
         CALL %SHOWBYTE
         POP AX
         CALL %SHOWBYTE
         RET
;
; SHOW REGISTERS
;
SHOWREGS PUSH ES
         MOV AX,[%SCRNSEG]
         MOV ES,AX
         MOV CX,0140 ; 4 LINES
         MOV AH,07 ; NORMAL
         MOV DI,0000
         MOV SI,%TXTREGS
SHOWREG1 LODSB ; DISPLAY TEMPLATE
         STOSW
         LOOP %SHOWREG1
;
         PUSH BP
         MOV BP,[%STORESP] ; DISPLAY REGISTER VALUES
         MOV AX,[%STOREAX]
         MOV DI,00AA
         CALL %SHOWWORD ; AX
         ADD DI,A
         MOV AX,[BP-2]
         CALL %SHOWWORD ; BX
         ADD DI,A
         MOV AX,[BP-4]
         CALL %SHOWWORD ; CX
         ADD DI,A
         MOV AX,[BP-6]
         CALL %SHOWWORD ; DX
         ADD DI,A
         MOV AX,[%STORESP]
         CALL %SHOWWORD ; SP
         ADD DI,A
         POP AX
         PUSH AX
         CALL %SHOWWORD ; BP
         ADD DI,A
         MOV AX,[BP-A]
         CALL %SHOWWORD ; SI
         ADD DI,A
         MOV AX,[BP-8]
         CALL %SHOWWORD ; DI
         MOV DI,014A
         MOV AX,[BP-E]
         CALL %SHOWWORD ; DS
         ADD DI,A
         MOV AX,[BP-C]
         CALL %SHOWWORD ; ES
         ADD DI,A
         MOV AX,SS
         CALL %SHOWWORD ; SS
         ADD DI,A
         MOV AX,[%STORECS]
         CALL %SHOWWORD ; CS
         ADD DI,A
         MOV AX,[%STOREIP]
         CALL %SHOWWORD ; IP
         ADD DI,10
;
         MOV BX,%FLAGTBL ; SHOW FLAGS
         MOV CX,8000
SHOWREG3 CMP [BX]B,FF
         JZ %SHOWREG2
         INC DI
         INC DI
         MOV DL,07 ; NORMAL - FLAG OFF
         MOV AX,[%STOREF]
         AND AX,CX
         JZ %SHOWREG4
         MOV DL,70 ; INVERTED - FLAG ON
SHOWREG4 MOV AH,DL
         MOV AL,[BX]
         STOSW
SHOWREG2 SHR CX,1
         INC BX
         OR CX,CX
         JNZ %SHOWREG3         
         POP BP
;
         MOV DI,0F00 ; BOTTOM LINE
         MOV SI,%TXTBOT
         MOV CX,0050
SHOWREG5 LODSB
         MOV AH,07
         CMP CL,50-02 ; HIGH-LIGHT KEY NAMES
         JAE %SHOWREG6
         CMP CL,50-0F
         JZ %SHOWREG6
         CMP CL,50-10
         JZ %SHOWREG6
         CMP CL,50-23
         JZ %SHOWREG6
         CMP CL,50-24
         JZ %SHOWREG6
         CMP CL,50-3C
         JZ %SHOWREG6
         CMP CL,50-3D
         JNZ %SHOWREG7
SHOWREG6 MOV AH,0F ; INTENSE
SHOWREG7 STOSW
         LOOP %SHOWREG5
         POP ES
         RET
;
; CHECK IF USER WANTS TO QUIT
;
CHKQUIT  MOV AH,03 ; SAVE CURSOR
         MOV BH,00
         INT 10
         MOV [%TRACCURS],DX
         MOV DI,%TRACSCRN
         CALL %SAVESCRN
         MOV AH,02 ; MOVE CURSOR
         MOV BH,00
         MOV DX,1734
         INT 10
;
         PUSH ES
         MOV AX,[%SCRNSEG]
         MOV ES,AX
         MOV SI,%TXTREGS
         MOV DI,0DC0
         MOV CX,0050
         MOV AH,07
CHKQUIT1 LODSB
         STOSW
         LOOP %CHKQUIT1
         MOV SI,%TXTQUIT
         MOV DI,0E60
         MOV CX,0050
CHKQUIT2 LODSB
         STOSW
         LOOP %CHKQUIT2
         MOV SI,%TXTREGS+F0
         MOV DI,0F00
         MOV CX,0050
CHKQUIT3 LODSB
         STOSW
         LOOP %CHKQUIT3
         POP ES
;
CHKQUIT4 MOV AH,01
         INT 16
         JZ %CHKQUIT4
         MOV AH,00
         INT 16
         CMP AH,1C ; ENTER
         JNZ %CHKQUIT5
         STC
         JMP %CHKQUIT6
CHKQUIT5 CLC
CHKQUIT6 PUSHF
         MOV SI,%TRACSCRN
         CALL %RESTSCRN
         MOV AH,02
         MOV BH,00
         MOV DX,[%TRACCURS]
         INT 10
         POPF
         RET
;
; SKIP TO SPECIFIED ADDRESS
;
SKIP     MOV DI,%TRACSCRN ; SAVE SCREEN
         CALL %SAVESCRN
         MOV AH,03
         MOV BH,00
         INT 10
         MOV [%TRACCURS],DX ; SAVE CURSOR
;
SKIP1    PUSH ES
         MOV AX,[%SCRNSEG]
         MOV ES,AX
         MOV SI,%TXTREGS
         MOV DI,0DC0 ; LINE 22
         MOV CX,0050
         MOV AH,07 ; NORMAL
SKIP2    LODSB
         STOSW
         LOOP %SKIP2
         MOV SI,%TXTBOX
         MOV DI,0E60 ; LINE 23
         MOV CX,0050
SKIP3    LODSB
         STOSW
         LOOP %SKIP3
         MOV SI,%TXTREGS+F0
         MOV DI,0F00 ; LINE 24
         MOV CX,0050
SKIP4    LODSB
         STOSW
         LOOP %SKIP4
         POP ES
         MOV AH,02 ; SET CURSOR POSITION
         MOV BH,00
         MOV DX,1701
         INT 10
         MOV AH,09
         MOV DX,%TXTSKIP
         INT 21
         MOV AH,02
         MOV BH,00
         MOV DX,1715
         INT 10
         MOV [%INPUTMAX]B,05 ; MAX 4 CHARACTERS (+CR)
;
SKIP8    MOV AH,01 ; WAIT FOR FIRST KEY
         INT 16
         JZ %SKIP8
;
         CMP AH,1C ; ENTER - USE DEFAULT
         JNZ %SKIP9
         MOV AH,00
         INT 16 ; PULL FROM BUFFER
         CMP [%LASTLABL]B,20
         JNZ %SKIP12
         MOV [%INPUTACT]B,00 ; NO INPUT
         JMP %SKIP11
SKIP12   MOV [%INPUTACT]B,04
         PUSH ES
         MOV AX,CS
         MOV ES,AX
         MOV SI,%LASTLABL ; MOVE DEFAULT INTO BUFFER
         MOV DI,%INPUTBUF
         MOV CX,0004
         REP
         MOVSB
         POP ES
         JMP %SKIP11
;
SKIP9    CMP AH,01 ; ESCAPE
         JNZ %SKIP10
         MOV AH,00
         INT 16 ; PULL FROM BUFFER
         MOV [%INPUTACT]B,00 ; NO INPUT
         JMP %SKIP11
;
SKIP10   PUSH ES ; BLANK OUT DEFAULT
         MOV ES,[%SCRNSEG]
         MOV AX,0720
         MOV DI,0E8A
         MOV CX,0004
         REP
         STOSW
         MOV AX,CS
         MOV ES,AX
         MOV AL,20
         MOV DI,%LASTLABL
         MOV CX,0004
         REP
         STOSB
         POP ES
;
         MOV AH,0A  ; INPUT ADDRESS
         MOV DX,%INPUTBLK
         INT 21
SKIP11   CMP [%INPUTACT]B,00
         JNZ %SKIP6
         CLC
         PUSHF
         JMP %SKIP5 ; NO INPUT
;
SKIP6    MOV CH,00
         MOV CL,[%INPUTACT]
         MOV BX,0000
         MOV SI,%INPUTBUF
SKIP7    SHL BX,1 ; BX:= BX*16
         SHL BX,1
         SHL BX,1
         SHL BX,1
         LODSB
         CALL %CNVNIB
         MOV AH,00
         ADD BX,AX
         LOOP %SKIP7
;
         PUSH ES
         MOV ES,[%COMSEG]
         ES:
         MOV AL,[BX] ; SAVE BYTE
         MOV [%SKIPSTOR],AL
         ES:
         MOV [BX]B,CC ; PLACE INT 3 TRAP
         POP ES
         STC
         PUSHF
;
SKIP5    MOV AH,02 ; RESTORE CURSOR POSITION
         MOV BH,00
         MOV DX,[%TRACCURS]
         INT 10
         MOV SI,%TRACSCRN
         CALL %RESTSCRN
         POPF
         RET
;
; COMPARE LABEL
;
COMPARE  MOV AX,[%CHRSEG]
         PUSH AX
         MOV AX,[%CHRPTR]
         PUSH AX
         MOV BX,%INPUTBUF
         MOV CH,00
         MOV CL,[%INPUTACT]
COMPARE2 CALL %READCHR
         CMP AL,[BX]
         JNZ %COMPARE1
         INC BX
         LOOP %COMPARE2
         CALL %READCHR
         CMP AL,20
         JNZ %COMPARE1
         STC ; MATCH
         JMP %COMPARE3
COMPARE1 CLC ; NO MATCH
COMPARE3 POP AX
         MOV [%CHRPTR],AX
         POP AX
         MOV [%CHRSEG],AX
         RET
;
; FIND LABEL
;
FINDLABL MOV DI,%TRACSCRN ; SAVE SCREEN
         CALL %SAVESCRN
         MOV AH,03
         MOV BH,00
         INT 10
         MOV [%TRACCURS],DX ; SAVE CURSOR
;
FINDLB20 PUSH ES
         MOV AX,[%SCRNSEG]
         MOV ES,AX
         MOV SI,%TXTREGS
         MOV DI,0DC0 ; LINE 22
         MOV CX,0050
         MOV AH,07 ; NORMAL
FINDLAB1 LODSB
         STOSW
         LOOP %FINDLAB1
         MOV SI,%TXTBOX
         MOV DI,0E60 ; LINE 23
         MOV CX,0050
FINDLAB2 LODSB
         STOSW
         LOOP %FINDLAB2
         MOV SI,%TXTREGS+F0
         MOV DI,0F00 ; LINE 24
         MOV CX,0050
FINDLAB3 LODSB
         STOSW
         LOOP %FINDLAB3
         MOV AH,02 ; SET CURSOR POSITION
         MOV BH,00
         MOV DX,1701
         INT 10
         MOV AH,09
         MOV DX,%TXTLABL
         INT 21
         MOV [%INPUTMAX]B,09 ; MAX 8 CHARACTERS (+CR)
;
         MOV AH,0A  ; INPUT LABEL NAME
         MOV DX,%INPUTBLK
         INT 21
         CMP [%INPUTACT]B,00
         JNZ %FINDLB18
         POP ES
         JMP %FINDLB19
;
FINDLB18 MOV AX,[%ADRSEG]
         MOV ES,AX
         MOV BX,[%ADROFSR]
         SUB BX,2
         SHL BX,1 ; TIMES BY 2
         ES:
         MOV AX,[BX]
         XOR CX,CX
         SHL AX,1
         JNC %FINDLAB5
         MOV CH,10
FINDLAB5 ADD CX,[%DMPSEG]
         MOV [%CHRSEG],CX
         MOV ES,CX
         MOV [%CHRPTR],AX
         MOV BX,AX
         ES:
         CMP [BX]B,0A
         JNZ %FINDLAB6
         INC [%CHRPTR]W
FINDLAB6 CALL %READLN
         MOV AX,[%CHRSEG]
         MOV ES,AX
         MOV BX,[%CHRPTR]
         ES:
         CMP [BX]B,2D ; '-'
         JNZ %FINDLAB6
FINDLB11 CALL %READLN
         MOV AX,[%CHRSEG]
         MOV ES,AX
         MOV BX,[%CHRPTR]
         ES:
         CMP [BX]B,0D
         JNZ %FINDLAB7 ; END OF LABELS
         CLC
         JMP %FINDLAB8
FINDLAB7 CALL %COMPARE
         JNC %FINDLAB9
         STC
         JMP %FINDLAB8
FINDLAB9 MOV CX,0F
FINDLB10 CALL %READCHR ; THROW AWAY REST
         LOOP %FINDLB10
         MOV AX,[%CHRSEG]
         MOV ES,AX
         MOV BX,[%CHRPTR]
         ES:
         CMP [BX]B,0D
         JZ %FINDLB11
         MOV CX,05
FINDLB12 CALL %READCHR
         LOOP %FINDLB12
         JMP %FINDLAB7
;
FINDLAB8 PUSHF
         MOV AX,[%SCRNSEG]
         MOV ES,AX
         MOV SI,%TXTBOX
         MOV DI,0E60
         MOV CX,0050
         MOV AH,07
FINDLB17 LODSB
         STOSW
         LOOP %FINDLB17
         MOV AH,02 ; MOVE CURSOR
         MOV BH,00
         MOV DX,1704
         INT 10
         POPF
         JC %FINDLB14
         MOV AH,09 ; NOT FOUND
         MOV DX,%TXTNOTF
         INT 21
         JMP %FINDLB15
FINDLB14 MOV CX,0F
         MOV AX,CS
         MOV ES,AX
         MOV DI,%LASTLABL
FINDLB16 CALL %READCHR ; GET CHARACTER
         MOV DL,AL
         CMP CL,04
         JA %FINDLB21
         STOSB
FINDLB21 MOV AH,02 ; DISPLAY CHARACTER
         INT 21
         LOOP %FINDLB16
;
FINDLB15 POP ES
FINDLAB4 MOV AH,01 ; WAIT FOR KEY
         INT 16
         JZ %FINDLAB4
         MOV AH,00
         INT 16
         CMP AH,40 ; F6
         JNZ %FINDLB19
         JMP %FINDLB20
;
FINDLB19 MOV AH,02 ; RESTORE CURSOR POSITION
         MOV BH,00
         MOV DX,[%TRACCURS]
         INT 10
         MOV SI,%TRACSCRN
         CALL %RESTSCRN
         RET
;
;
;  TRACE - SINGLE-STEP TRAP ROUTINE
;
TRACE    STI
         CS:
         MOV [%STOREAX],AX ; SAVE AX
         POP AX    ; PULL ADDRESS AND FLAGS OFF STACK
         CS:
         MOV [%STOREIP],AX
         POP AX
         CS:
         MOV [%STORECS],AX
         POP AX
         CS:
         MOV [%STOREF],AX
         CS:
         MOV [%STORESP],SP
         PUSH BX ; SAVE REGISTERS
         PUSH CX
         PUSH DX
         PUSH DI
         PUSH SI
         PUSH ES
         PUSH DS
;
         MOV AX,CS ; SET DS
         MOV DS,AX
;
         MOV AX,[%STORECS]
         CMP AX,[%COMSEG]
         JZ %TRACE2
         JMP %TRACE16 ; RETURN FROM INTERRUPT
TRACE14  MOV AH,09
         MOV DX,%TXTIPERR
         INT 21
         JMP %TRACE4
;
TRACE2   MOV DI,%USERSCRN ; SWAP SCREEN DISPLAYS
         CALL %SAVESCRN
         MOV SI,%TRACSCRN
         CALL %RESTSCRN
         CALL %SAVECURS
;
         MOV ES,[%ADRSEG]
         XOR DI,DI
         MOV CX,[%ADROFSR]
         DEC CX
         DEC CX
         MOV AX,[%STOREIP]
         REPNE
         SCASW
         JCXZ %TRACE14
;
TRACE4   ES:
         MOV AX,[DI-4] ; LOOK AT PREVIOUS ENTRY
         CMP AX,[%LASTADR]
         JZ %TRACE8
         MOV AH,09 ; DISPLAY BOUNDARY
         MOV DX,%TXTCHGAD
         INT 21
         CALL %TRACE17 ; LINEFEED
;
TRACE8   ADD DI,[%ADROFSR]  ; DISPLAY THE SOURCE CODE LINE(S)
         SUB DI,2
         ES:
         MOV AX,[DI]
         ES:
         MOV SI,[DI+2]
         MOV CX,[%DMPSEG]
         SHL SI,1
         JNC %TRACE23
         ADD CX,1000 ; NEXT 64K PAGE
TRACE23  MOV BX,[%DMPSEG]
         SHL AX,1
         JNC %TRACE5
         ADD BX,1000 ; NEXT 64K PAGE
TRACE5   MOV ES,BX
         MOV BX,AX
         ES:
         CMP [BX]B,0A
         JNZ %TRACE7
         INC BX
         CMP BX,0000
         JNZ %TRACE7
         MOV AX,ES
         ADD AX,1000
         MOV ES,AX
TRACE7   PUSH ES
         MOV ES,CX
         ES:
         CMP [SI]B,0A
         POP ES
         JNZ %TRACE6
         INC SI
         CMP SI,0000
         JNZ %TRACE6
         ADD CX,1000
TRACE6   ES:
         MOV DL,[BX] ; READ A CHARACTER
         CMP DL,0A
         JNZ %TRACE9
         CALL %TRACE17
         JMP %TRACE10
;
TRACE17  PUSH BX
         PUSH CX
         MOV AH,03
         MOV BH,00
         INT 10
         CMP DH,17
         JAE %TRACE12 ; DO NOT SCROLL UNLESS Y>=17
         MOV AH,02
         INC DH
         INT 10 ; MOVE CURSOR DOWN 1 LINE
         JMP %TRACE11
TRACE12  MOV AX,0601 ; SCROLL THE SOURCE CODE WINDOW
         MOV BH,07
         MOV CX,0400
         MOV DX,174F
         INT 10
TRACE11  POP CX
         POP BX
         RET
;
TRACE9   MOV AH,02
         INT 21  ; DISPLAY A CHARACTER
TRACE10  INC BX
         CMP BX,0000
         JNZ %TRACE24
         MOV AX,ES
         ADD AX,1000
         MOV ES,AX
TRACE24  MOV AX,ES
         CMP AX,CX
         JB %TRACE6
         CMP BX,SI
         JB %TRACE6
;
         MOV AX,[%STOREIP] ; UPDATE LAST ADDRESS TRACED
         MOV [%LASTADR],AX
;
         CALL %SHOWREGS  ; DISPLAY REGISTERS
;
TRACE1   MOV AH,01 ; WAIT FOR KEY-PRESS
         INT 16
         JZ %TRACE1
         MOV AH,00
         INT 16
;
         CMP AH,01 ; ESCAPE
         JNZ %TRACE15
         CALL %CHKQUIT
         JNC %TRACE1
;
         MOV AX,[%STOREF] ; TURN OFF SINGLE-STEP
         AND AX,FEFF
         MOV [%STOREF],AX
         MOV [%STOREIP]W,0000 ; FORCE TERMINATION
         STI ; ENSURE INTERRUPTS ARE ENABLED
         JMP %TRACE3
;
TRACE15  CMP AH,40 ; F6 - FIND LABEL
         JNZ %TRACE18
         CALL %FINDLABL
         JMP %TRACE1 ; GET NEXT KEY-PRESS
;
TRACE18  CMP AH,42 ; F8 - SWITCH SCREEN
         JNZ %TRACE19
         MOV DI,%TRACSCRN
         CALL %SAVESCRN
         MOV SI,%USERSCRN
         CALL %RESTSCRN
         CALL %RESTCURS
TRACE20  MOV AH,01
         INT 16
         JZ %TRACE20
         MOV AH,00
         INT 16
         CMP AH,01 ; ESCAPE
         JZ %TRACE21
         CMP AH,42 ; F8
         JNZ %TRACE20
TRACE21  MOV SI,%TRACSCRN
         CALL %RESTSCRN
         CALL %SAVECURS
         JMP %TRACE1 ; GET NEXT KEY-PRESS
;
TRACE19  CMP AH,41 ; F7 - SKIP
         JNZ %TRACE22
         CALL %SKIP
         JNC %TRACE1
         AND [%STOREF]W,FEFF ; TURN OFF SINGLE-STEP
         JMP %TRACE3 ; RETURN TO CODE
;
TRACE22 ; CONTINUE
;
TRACE3   MOV DI,%TRACSCRN
         CALL %SAVESCRN
         MOV SI,%USERSCRN
         CALL %RESTSCRN
         CALL %RESTCURS
TRACE16  POP DS ; RESTORE REGISTERS
         POP ES
         POP SI
         POP DI
         POP DX
         POP CX
         POP BX
         CS:
         MOV AX,[%STOREF]  ; RESTORE RETURN ADDRESS TO STACK
         PUSH AX
         CS:
         MOV AX,[%STORECS]
         PUSH AX
         CS:
         MOV AX,[%STOREIP]
         PUSH AX
         CS:
         MOV AX,[%STOREAX] ; RESTORE AX
         IRET
;
;
; TRAP FOR INT 03 - SKIP MODE
;
TRAP     STI
         CS:
         MOV [%STOREAX],AX
         POP AX
         CS:
         MOV [%STOREIP],AX
         POP AX
         CS:
         MOV [%STORECS],AX
         POP AX
         CS:
         MOV [%STOREF],AX
         PUSH DS
         PUSH ES
         PUSH BX
         MOV AX,CS
         MOV DS,AX
         MOV AX,[%STORECS]
         MOV ES,AX
         DEC [%STOREIP]W
         MOV BX,[%STOREIP]
         MOV AL,[%SKIPSTOR]
         ES:
         MOV [BX],AL ; RESTORE ALTERED BYTE
         OR [%STOREF]W,0100 ; TURN SINGLE-STEP ON
         POP BX
         POP ES
         POP DS
         CS:
         MOV AX,[%STOREF]
         PUSH AX
         CS:
         MOV AX,[%STORECS]
         PUSH AX
         CS:
         MOV AX,[%STOREIP]
         PUSH AX
         CS:
         MOV AX,[%STOREAX]
         IRET
;
;
; MAIN PROGRAM
;
MAIN     MOV AX,%ENDSTCK ; SET UP STACK
         MOV SP,AX
         XOR AX,AX
         PUSH AX
;
         CALL %COMDLINE
         CALL %READDMP
         CALL %MAKEADR
         CALL %RUNCOM
;
         MOV AX,4C00 ; TERMINATE
         INT 21
;
PRGEND   ; END OF PROGRAM CODE
ENDSTCK  = %PRGEND+80 ; STACK IS 128 BYTES
USERSCRN = %ENDSTCK+2 ; USER SCREEN SAVE AREA
TRACSCRN = %USERSCRN+0FA0 ; TRACE SCREEN SAVE AREA
ENDSPACE = %TRACSCRN+0FA0
