                                    TRACE                  21/12/89   AJD
                                    -----
    
    Trace is a utility for use with ASSEMBLE.  Trace allows you to step
    through your assembler source code one instruction at a time and
    observe the registers and flags.  Trace also allows you to view the
    values that your programs' labels took on at assembly time, and allows 
    you to skip to specified locations in your program.
    
    To use Trace you must assemble your assembler program using ASSEMBLE
    with the -O option.  This option makes ASSEMBLE create a .DMP file
    which contains a copy of the screen output during assembly (see the
    ASSEMBLE manual).  Trace uses both the .DMP file and the .COM file
    produced by ASSEMBLE.  After the assembly has been performed (and no
    errors or warnings were issued), you may type:  TRACE filename   ,
    where filename is the name of your assembler program without any
    suffix. If your program requires command line parameters then these may
    be entered after the pathname as usual.
    
    Upon entering Trace, the top of the screen shows the current values of 
    the registers and flags.  Flags that are set are indicated with reverse
    video.  Below this is the first line of source code in your program
    (which has not yet been executed).  At the bottom of the screen is a
    list of the keys which have special functions in Trace.
    
    Pressing a key other than one of those shown at the bottom of the
    screen will cause the currently displayed line of code to be executed. 
    The screen will flash as the screen contents are swapped, the
    instruction is executed, and the screen contents are swapped again. 
    The user screen is preserved so that output from the program being
    traced may be observed (see the F8 key below).
    
    During tracing, when the instruction pointer (IP) changes to a value
    other than that of the next sequential instruction then a line is drawn
    across the screen to indicate that some form of branch has occured. 
    Some instructions seem to disable the trace flag temporarily, so
    sometimes a line may be drawn across even though no branch has
    occured.
    
    
    The special keys available while using Trace are:
    
    Escape  - Quit.  This key enables you to quit tracing a program before 
    the program you are tracing actually finishes.
    
    F6  - Find Label.  This key prompts you for the name of a label in your
    program and displays the value of the label (if it is found).  This
    value is also made the new default for the Skip command (F7).
    
    F7  - Skip.  This key prompts you for an address in your program which 
    you wish to skip to.  To use the default value (if one is displayed),
    simply press enter.  Skipping means that the trace flag will be turned 
    off and Trace will not regain control until the specified location is
    reached.  It may be possible that your program never reaches the
    specified address  -  if this is the case then Trace will never regain 
    control.
    
    F8  - Swap screens.  This key flips the screen displayed from the Trace
    screen to the user program screen and back again.  This is useful if
    your program displays output to the screen.
